Index: branches/TAM_V3_0/NEMOTAM/OPATAM_SRC/dotprodfld.F90
===================================================================
--- branches/TAM_V3_0/NEMOTAM/OPATAM_SRC/dotprodfld.F90	(revision 1947)
+++ branches/TAM_V3_0/NEMOTAM/OPATAM_SRC/dotprodfld.F90	(revision 2587)
@@ -10,5 +10,14 @@
    !! * Modules used   
    USE par_kind
-   USE dom_oce
+   USE dom_oce, ONLY :       &
+      & nldi,                &
+      & nldj,                &
+      & nlei,                &
+      & nlej
+   USE par_oce       , ONLY: & ! Ocean space and time domain variables
+      & jpi,                 &
+      & jpj,                 & 
+      & jpk
+
    USE mppsumtam
 
Index: branches/TAM_V3_0/NEMOTAM/OPATAM_SRC/eosbn2_tam.F90
===================================================================
--- branches/TAM_V3_0/NEMOTAM/OPATAM_SRC/eosbn2_tam.F90	(revision 1947)
+++ branches/TAM_V3_0/NEMOTAM/OPATAM_SRC/eosbn2_tam.F90	(revision 2587)
@@ -130,6 +130,8 @@
    PUBLIC eos_adj_tst
    PUBLIC bn2_adj_tst
+#if defined key_tst_tlm
    PUBLIC eos_tlm_tst
    PUBLIC bn2_tlm_tst
+#endif
 #endif
    
@@ -3057,5 +3059,5 @@
 
    END SUBROUTINE bn2_adj_tst
-
+#if defined key_tst_tlm
    SUBROUTINE eos_insitu_tlm_tst( kumadt )
       !!-----------------------------------------------------------------------
@@ -3091,4 +3093,5 @@
       USE tamtrj              ! writing out state trajectory
       USE par_tlm,    ONLY: &
+        & tlm_bch,          &
         & cur_loop,         &
         & h_ratio
@@ -3134,5 +3137,5 @@
          & jk
       CHARACTER(LEN=14)   :: cl_name
-      CHARACTER (LEN=128) :: file_out_sc, file_wop, file_out
+      CHARACTER (LEN=128) :: file_out_sc, file_wop, file_out, file_xdx
       CHARACTER (LEN=90)  :: FMT
       REAL(KIND=wp), DIMENSION(100):: &
@@ -3160,15 +3163,15 @@
       zs_tlin(  :,:,:)   = 0.0_wp
       zrd_out(  :,:,:)   = 0.0_wp 
-      zrd_tl (  :,:,:)   = 0.0_wp
       zrd_wop(  :,:,:)   = 0.0_wp
       zscerrrd(:)        = 0.0_wp
       zscrd(:)           = 0.0_wp
-
+      IF ( tlm_bch == 2 ) zrd_tl (  :,:,:)   = 0.0_wp    
       !--------------------------------------------------------------------
       ! Output filename Xn=F(X0)
       !--------------------------------------------------------------------
-      file_wop='trj_wop_eos_insitu'
       CALL tlm_namrd
       gamma = h_ratio
+      file_wop='trj_wop_eos_insitu'
+      file_xdx='trj_xdx_eos_insitu'
       !--------------------------------------------------------------------
       ! Initialize the tangent input with random noise: dx
@@ -3196,5 +3199,5 @@
       ! Complete Init for Direct
       !-------------------------------------------------------------------
-      CALL istate_p  
+      IF ( tlm_bch /= 2 )  CALL istate_p  
 
       ! *** initialize the reference trajectory
@@ -3213,14 +3216,12 @@
       !  Compute the direct model F(X0,t=n) = Xn
       !--------------------------------------------------------------------      
-      CALL eos(tn, sn, zrd_out)
+      IF ( tlm_bch /= 2 )  CALL eos(tn, sn, zrd_out)
       rhd(:,:,:)= zrd_out(:,:,:)
-      IF ( cur_loop .EQ. 0) CALL trj_wri_spl(file_wop)
+      IF ( tlm_bch == 0 ) CALL trj_wri_spl(file_wop)
+      IF ( tlm_bch == 1 ) CALL trj_wri_spl(file_xdx)
       !--------------------------------------------------------------------
       !  Compute the Tangent 
       !--------------------------------------------------------------------
-      IF ( cur_loop .NE. 0) THEN
-         !--------------------------------------------------------------------
-         !  Storing data
-         !--------------------------------------------------------------------
+      IF ( tlm_bch == 2 ) THEN
          !--------------------------------------------------------------------
          ! Initialize the tangent variables: dy^* = W dy  
@@ -3241,5 +3242,6 @@
          CALL trj_rd_spl(file_wop) 
          zrd_wop  (:,:,:) = rhd  (:,:,:)
-
+         CALL trj_rd_spl(file_xdx) 
+         zrd_out  (:,:,:) = rhd  (:,:,:)
          !--------------------------------------------------------------------
          ! Compute the Linearization Error 
@@ -3367,4 +3369,5 @@
       USE tamtrj              ! writing out state trajectory
       USE par_tlm,    ONLY: &
+        & tlm_bch,          &
         & cur_loop,         &
         & h_ratio
@@ -3416,5 +3419,5 @@
          & jk
       CHARACTER(LEN=14)   :: cl_name
-      CHARACTER (LEN=128) :: file_out, file_wop
+      CHARACTER (LEN=128) :: file_out, file_wop,file_xdx
       CHARACTER (LEN=90)  :: FMT
       REAL(KIND=wp), DIMENSION(100):: &
@@ -3447,6 +3450,4 @@
       zrd_out(  :,:,:)   = 0.0_wp
       zrh_out(  :,:,:)   = 0.0_wp 
-      zrd_tl (  :,:,:)   = 0.0_wp
-      zrh_tl (  :,:,:)   = 0.0_wp
       zrd_wop(  :,:,:)   = 0.0_wp
       zrh_wop(  :,:,:)   = 0.0_wp
@@ -3455,11 +3456,15 @@
       zscrd(:)           = 0.0_wp
       zscrh(:)           = 0.0_wp
-
+      IF ( tlm_bch == 2 )  THEN
+         zrd_tl (  :,:,:)   = 0.0_wp
+         zrh_tl (  :,:,:)   = 0.0_wp
+      ENDIF
       !--------------------------------------------------------------------
       ! Output filename Xn=F(X0)
       !--------------------------------------------------------------------
-      file_wop='trj_wop_eos_pot'
       CALL tlm_namrd
       gamma = h_ratio 
+      file_wop='trj_wop_eos_pot'
+      file_xdx='trj_xdx_eos_pot'
       !--------------------------------------------------------------------
       ! Initialize the tangent input with random noise: dx
@@ -3486,5 +3491,5 @@
       ! Complete Init for Direct
       !-------------------------------------------------------------------
-      CALL istate_p  
+      IF ( tlm_bch /= 2 )  CALL istate_p  
 
       ! *** initialize the reference trajectory
@@ -3503,15 +3508,13 @@
       !  Compute the direct model F(X0,t=n) = Xn
       !--------------------------------------------------------------------      
-      CALL eos(tn, sn, zrd_out, zrh_out)
+      IF ( tlm_bch /= 2 )      CALL eos(tn, sn, zrd_out, zrh_out)
       rhd (:,:,:) = zrd_out(:,:,:)
       rhop(:,:,:) = zrh_out(:,:,:)
-      IF ( cur_loop .EQ. 0) CALL trj_wri_spl(file_wop)
+      IF ( tlm_bch == 0 ) CALL trj_wri_spl(file_wop)
+      IF ( tlm_bch == 1 ) CALL trj_wri_spl(file_xdx)
       !--------------------------------------------------------------------
       !  Compute the Tangent 
       !--------------------------------------------------------------------
-      IF ( cur_loop .NE. 0) THEN
-         !--------------------------------------------------------------------
-         !  Storing data
-         !--------------------------------------------------------------------
+      IF ( tlm_bch == 2 ) THEN
          !--------------------------------------------------------------------
          ! Initialize the tangent variables: dy^* = W dy  
@@ -3536,5 +3539,7 @@
          zrd_wop  (:,:,:) = rhd  (:,:,:)
          zrh_wop  (:,:,:) = rhop (:,:,:)
-
+         CALL trj_rd_spl(file_xdx) 
+         zrd_out  (:,:,:) = rhd  (:,:,:)
+         zrh_out  (:,:,:) = rhop (:,:,:)
          !--------------------------------------------------------------------
          ! Compute the Linearization Error 
@@ -3695,4 +3700,5 @@
       USE tamtrj              ! writing out state trajectory
       USE par_tlm,    ONLY: &
+        & tlm_bch,          &
         & cur_loop,         &
         & h_ratio
@@ -3741,5 +3747,5 @@
          & jj
       CHARACTER(LEN=14)   :: cl_name
-      CHARACTER (LEN=128) :: file_out, file_wop
+      CHARACTER (LEN=128) :: file_out, file_wop, file_xdx
       CHARACTER (LEN=90)  :: FMT
       REAL(KIND=wp), DIMENSION(100):: &
@@ -3771,16 +3777,15 @@
       zs_tlin(  :,:)   = 0.0_wp
       zrd_out(  :,:)   = 0.0_wp 
-      zrd_tl (  :,:)   = 0.0_wp
       zrd_wop(  :,:)   = 0.0_wp
       zscerrrd( :)     = 0.0_wp
       zscrd(:)         = 0.0_wp
-
+      IF ( tlm_bch == 2 )      zrd_tl (  :,:)   = 0.0_wp
       !--------------------------------------------------------------------
       ! Output filename Xn=F(X0)
       !--------------------------------------------------------------------
-      file_wop='trj_wop_eos_2d'
-
       CALL tlm_namrd
       gamma = h_ratio
+      file_wop='trj_wop_eos_2d'
+      file_xdx='trj_xdx_eos_2d'
       !--------------------------------------------------------------------
       ! Initialize the tangent input with random noise: dx
@@ -3804,5 +3809,5 @@
       ! Complete Init for Direct
       !-------------------------------------------------------------------
-      CALL istate_p  
+      IF ( tlm_bch /= 2 ) CALL istate_p  
       ! *** initialize the reference trajectory
       ! ------------
@@ -3824,14 +3829,12 @@
       !  Compute the direct model F(X0,t=n) = Xn
       !--------------------------------------------------------------------    
-      CALL eos(ztem, zsal, zdep, zrd_out)
+      IF ( tlm_bch /= 2 ) CALL eos(ztem, zsal, zdep, zrd_out)
       rhd (:,:,2) = zrd_out(:,:)
-      IF ( cur_loop .EQ. 0) CALL trj_wri_spl(file_wop)
+      IF ( tlm_bch == 0 ) CALL trj_wri_spl(file_wop)
+      IF ( tlm_bch == 1 ) CALL trj_wri_spl(file_xdx)
       !--------------------------------------------------------------------
       !  Compute the Tangent 
       !--------------------------------------------------------------------
-      IF ( cur_loop .NE. 0) THEN
-         !--------------------------------------------------------------------
-         !  Storing data
-         !--------------------------------------------------------------------
+      IF ( tlm_bch == 2 ) THEN
          !--------------------------------------------------------------------
          ! Initialize the tangent variables: dy^* = W dy  
@@ -3854,4 +3857,6 @@
          CALL trj_rd_spl(file_wop) 
          zrd_wop  (:,:) = rhd  (:,:,2)
+         CALL trj_rd_spl(file_xdx) 
+         zrd_out  (:,:) = rhd  (:,:,2)
          !--------------------------------------------------------------------
          ! Compute the Linearization Error 
@@ -3976,4 +3981,5 @@
       USE tamtrj              ! writing out state trajectory
       USE par_tlm,    ONLY: &
+        & tlm_bch,          &
         & cur_loop,         &
         & h_ratio
@@ -4023,5 +4029,5 @@
          & z3r                
       CHARACTER(LEN=14)   :: cl_name
-      CHARACTER (LEN=128) :: file_out, file_wop
+      CHARACTER (LEN=128) :: file_out, file_wop, file_xdx
       CHARACTER (LEN=90)  :: FMT
       REAL(KIND=wp), DIMENSION(100):: &
@@ -4051,8 +4057,8 @@
       ! Output filename Xn=F(X0)
       !--------------------------------------------------------------------
-      file_wop='trj_wop_bn2'
-
       CALL tlm_namrd
       gamma = h_ratio    
+      file_wop='trj_wop_bn2'
+      file_xdx='trj_xdx_bn2'  
       !--------------------------------------------------------------------
       ! Initialize the tangent input with random noise: dx
@@ -4079,5 +4085,5 @@
       ! Complete Init for Direct
       !-------------------------------------------------------------------
-      CALL istate_p  
+      IF ( tlm_bch /= 2 ) CALL istate_p  
 
       ! *** initialize the reference trajectory
@@ -4098,15 +4104,11 @@
       !  Compute the direct model F(X0,t=n) = Xn
       !--------------------------------------------------------------------
-      CALL bn2(tn, sn, rn2)
-      IF ( cur_loop .EQ. 0) CALL trj_wri_spl(file_wop)
+      IF ( tlm_bch /= 2 ) CALL bn2(tn, sn, rn2)
+      IF ( tlm_bch == 0 ) CALL trj_wri_spl(file_wop)
+      IF ( tlm_bch == 1 ) CALL trj_wri_spl(file_xdx)
       !--------------------------------------------------------------------
       !  Compute the Tangent 
       !--------------------------------------------------------------------
-      IF ( cur_loop .NE. 0) THEN
-         !--------------------------------------------------------------------
-         !  Storing data
-         !--------------------------------------------------------------------
-         zrn2_out  (:,:,:) = rn2   (:,:,:)         
-
+      IF ( tlm_bch == 2 ) THEN
          !--------------------------------------------------------------------
          ! Initialize the tangent variables: dy^* = W dy  
@@ -4131,5 +4133,6 @@
          CALL trj_rd_spl(file_wop) 
          zrn2_wop  (:,:,:) = rn2  (:,:,:)
-
+         CALL trj_rd_spl(file_xdx) 
+         zrn2_out  (:,:,:) = rn2  (:,:,:)
          !--------------------------------------------------------------------
          ! Compute the Linearization Error 
@@ -4244,4 +4247,5 @@
    END SUBROUTINE eos_tlm_tst
 #endif
+#endif
    !!======================================================================
 END MODULE eosbn2_tam
Index: branches/TAM_V3_0/NEMOTAM/OPATAM_SRC/hlttst.F90
===================================================================
--- branches/TAM_V3_0/NEMOTAM/OPATAM_SRC/hlttst.F90	(revision 2587)
+++ branches/TAM_V3_0/NEMOTAM/OPATAM_SRC/hlttst.F90	(revision 2587)
@@ -0,0 +1,75 @@
+MODULE hlttst
+#ifdef key_tam
+   !!======================================================================
+   !!                       ***  MODULE hlt_tst  ***
+   !! NEMOTAM    : testing routine of linear-tangent hypothesis
+   !!======================================================================
+   !! History : 
+   !! the direct:      !  10-07  (F. Vigilant)  Original code
+   !!-----------------------------------------------------------------------
+   !! * Module used
+   USE in_out_manager  ! I/O manager
+   USE par_tlm
+   USE opahlt, ONLY: &
+     & opa_hlt
+   USE tanhlt, ONLY: &
+     & tan_hlt
+   USE hltinc
+
+   IMPLICIT NONE
+
+   !! * Routine accessibility
+   PRIVATE
+
+   PUBLIC &
+      & hlt_tst 
+
+CONTAINS
+
+   SUBROUTINE hlt_tst
+      !!-----------------------------------------------------------------------
+      !!
+      !!                  ***  ROUTINE hlt_tst  ***
+      !!
+      !! ** Purpose : Validate the linear-tangent hypothesis of the tangent with
+      !!              with respect to the direct model
+      !!
+      !! ** Method  : Build or read a perturbation control vector dX and save
+      !!              M(X, t=tO+p.T), M(X+dX, t=tO+p.T), LT(dX, t=tO+p.T)
+      !!              t0=nit000
+      !!              t = (nit000, nitend)
+      !!              T: saving frequency
+      !!
+      !!              Post treatment need to be done to analyze the RMS of:
+      !!              Y(t) = M(X, t=tO+p.T) - M(X+dX, t=tO+p.T) - LT(dX, t=tO+p.T)
+      !!
+      !!              Then, this routine is run three times
+      !!
+      !! ** Action  : Use 'nstg' swith as follows:
+      !!                     0:  compute M(X, t=tO+p.T)
+      !!                     1:  compute M(X+dX, t=tO+p.T)
+      !!                     2:  compute LT(dX, t=tO+p.T)
+      !!                     3:  compute and save dX only
+      !!                   
+      !! History : 
+      !!        ! 10-07 (F. Vigilant) original code
+      !!-----------------------------------------------------------------------
+      !! * Modules used
+
+      !! * Arguments
+      !! * Local declarations
+
+      SELECT CASE( nstg )
+      CASE ( 0, 1, 3)
+         CALL opa_hlt
+      CASE ( 2 )
+         CALL tan_hlt
+      CASE DEFAULT
+         CALL ctl_stop( '       Wrong value for hlt stage nstg. Must be 0, 1 or 2')
+      END SELECT
+
+
+   END SUBROUTINE hlt_tst
+
+#endif
+END MODULE hlttst
Index: branches/TAM_V3_0/NEMOTAM/OPATAM_SRC/istate_tam.F90
===================================================================
--- branches/TAM_V3_0/NEMOTAM/OPATAM_SRC/istate_tam.F90	(revision 1947)
+++ branches/TAM_V3_0/NEMOTAM/OPATAM_SRC/istate_tam.F90	(revision 2587)
@@ -45,5 +45,6 @@
 #  endif
 # endif
-      & tmask, umask, vmask
+      & tmask, umask, vmask, &
+      & n_cla
    USE daymod        , ONLY: &
       & day_init
@@ -61,4 +62,8 @@
    USE eosbn2_tam    , ONLY: &
       & eos_tan, eos_adj
+   USE divcur_tam    , ONLY: &
+      & div_cur_tan, div_cur_adj
+   USE cla_div_tam    , ONLY: &
+      & div_cla_tan, div_cla_adj
    USE tstool_tam    , ONLY: &
       & prntst_adj,          &
@@ -119,7 +124,7 @@
       sb_tl   (:,:,:) = sn_tl   (:,:,:)
       sshb_tl (  :,:) = sshn_tl (  :,:)
-      rotb_tl (:,:,:) = rotn_tl (:,:,:)  
+      !
+      rotb_tl (:,:,:) = rotn_tl (:,:,:)   ! Update before fields
       hdivb_tl(:,:,:) = hdivn_tl(:,:,:)  
-      !
 
 
Index: branches/TAM_V3_0/NEMOTAM/OPATAM_SRC/model_hlt.F90
===================================================================
--- branches/TAM_V3_0/NEMOTAM/OPATAM_SRC/model_hlt.F90	(revision 2587)
+++ branches/TAM_V3_0/NEMOTAM/OPATAM_SRC/model_hlt.F90	(revision 2587)
@@ -0,0 +1,9 @@
+PROGRAM model_hlt
+#if defined key_tam
+   USE nemotam_hlt
+   IMPLICIT NONE
+   CALL nemotam_hlt_main
+#else
+   WRITE(*,*)'Compile with -Dkey_tam'
+#endif
+END PROGRAM model_hlt
Index: branches/TAM_V3_0/NEMOTAM/OPATAM_SRC/mpp_tam.F90
===================================================================
--- branches/TAM_V3_0/NEMOTAM/OPATAM_SRC/mpp_tam.F90	(revision 1947)
+++ branches/TAM_V3_0/NEMOTAM/OPATAM_SRC/mpp_tam.F90	(revision 2587)
@@ -47,5 +47,6 @@
       & mpp_sum_reals,      &
       & mpp_global_or,      &
-      & mpp_global_max_real
+      & mpp_global_max_real, &
+      & mpp_global_max_real2
 
 CONTAINS
@@ -151,5 +152,5 @@
    SUBROUTINE mpp_global_max_real( zin, zout )
       !!----------------------------------------------------------------------
-      !!               ***  ROUTINE mpp_global_or ***
+      !!               ***  ROUTINE mpp_global_max_real ***
       !!          
       !! ** Purpose : Copy a local zin array to a global array and
@@ -213,3 +214,68 @@
    END SUBROUTINE mpp_global_max_real
 
+
+   SUBROUTINE mpp_global_max_real2( zin, zout )
+      !!----------------------------------------------------------------------
+      !!               ***  ROUTINE mpp_global_max_real2 ***
+      !!          
+      !! ** Purpose : Copy a local zin array to a global array and
+      !!              apply the "max" operation for all elements in
+      !!              a global (jpiglo,jpjglo) array across processors
+      !!
+      !! ** Method  : MPI allreduce
+      !!
+      !! ** Action  : This does only work for MPI. 
+      !!              It does not work for SHMEM.
+      !!
+      !! References : http://www.mpi-forum.org
+      !!
+      !! History :
+      !!        !  08-01  (K. Mogensen)  Original code
+      !!----------------------------------------------------------------------
+
+      !! * Arguments
+      REAL(wp), DIMENSION(jpi,jpj), INTENT(IN) :: &
+         & zin
+      REAL(wp), DIMENSION(jpiglo,jpjglo), INTENT(OUT) :: &
+         & zout
+      !! * Local declarations
+      INTEGER :: &
+         & ierr
+#if defined key_mpp_mpi
+#include <mpif.h>
+      REAL(wp), DIMENSION(:,:), ALLOCATABLE :: &
+         & zcp
+      INTEGER :: &
+         & ji, &
+         & jj
+      
+      ! Copy data for input to MPI
+
+      ALLOCATE( &
+         & zcp(jpiglo,jpjglo) &
+         & )
+      zcp(:,:) = -1e+38
+      DO jj = nldj, nlej
+         DO ji = nldi, nlei
+            zcp(mig(ji),mjg(jj)) = zin(ji,jj)
+         ENDDO
+      ENDDO
+
+      ! Call the MPI library to find the coast lines globally
+
+      CALL mpi_allreduce( zcp, zout, jpiglo*jpjglo, mpivar, &
+         &                mpi_max, mpi_comm_opa, ierr )
+
+      DEALLOCATE( &
+         & zcp &
+         & )
+
+#elif defined key_mpp_shmem
+#error "Only MPI support for MPP in NEMOVAR"
+#else
+      zout(:,:) = zin(:,:)
+#endif
+      
+   END SUBROUTINE mpp_global_max_real2
+   
 END MODULE mpp_tam
Index: branches/TAM_V3_0/NEMOTAM/OPATAM_SRC/mt19937ar.f90
===================================================================
--- branches/TAM_V3_0/NEMOTAM/OPATAM_SRC/mt19937ar.f90	(revision 2587)
+++ branches/TAM_V3_0/NEMOTAM/OPATAM_SRC/mt19937ar.f90	(revision 2587)
@@ -0,0 +1,233 @@
+MODULE mt19937ar
+   !!======================================================================
+   !!                       ***  MODULE  mt19937ar ***
+   !! Mersen Twister random generator
+   !!======================================================================
+   !!                 
+   !! ** Purpose :
+   !! ** Method  :  
+   !! References : This a a Fortran90 translation of mt19937ar.c:
+   !! A C-program for MT19937, with initialization improved 2002/1/26.
+   !! Coded by Takuji Nishimura and Makoto Matsumoto.
+   !!
+   !! Before using, initialize the state by using init_genrand(seed)  
+   !! or init_by_array(init_key, key_length).
+   !!
+   !! Copyright (C) 1997 - 2002, Makoto Matsumoto and Takuji Nishimura,
+   !! All rights reserved.                          
+   !!
+   !! Redistribution and use in source and binary forms, with or without
+   !! modification, are permitted provided that the following conditions
+   !! are met:
+   !!
+   !!   1. Redistributions of source code must retain the above copyright
+   !!      notice, this list of conditions and the following disclaimer.
+   !!
+   !!   2. Redistributions in binary form must reproduce the above copyright
+   !!      notice, this list of conditions and the following disclaimer in the
+   !!      documentation and/or other materials provided with the distribution.
+   !!
+   !!   3. The names of its contributors may not be used to endorse or promote 
+   !!      products derived from this software without specific prior written 
+   !!      permission.
+   !!
+   !! THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
+   !! "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
+   !! LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
+   !! A PARTICULAR PURPOSE ARE DISCLAIMED.  IN NO EVENT SHALL THE COPYRIGHT OWNER OR
+   !! CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL,
+   !! EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
+   !! PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR
+   !! PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF
+   !! LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING
+   !! NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
+   !! SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
+   !!
+   !!
+   !! Any feedback is very welcome.
+   !! http://www.math.sci.hiroshima-u.ac.jp/~m-mat/MT/emt.html
+   !! email: m-mat @ math.sci.hiroshima-u.ac.jp (remove space)
+   !!
+   !! Until 2001/4/6, MT had been distributed under GNU Public License, 
+   !! but after 2001/4/6, we decided to let MT be used for any purpose, 
+   !! including commercial use. 2002-versions mt19937ar.c, mt19937ar-cok.c 
+   !! are considered to be usable freely. 
+   !!      
+   !! History: 
+   !!        !  97 - 02 (Makoto Matsumoto/Takuji Nishimura) original c version
+   !!        !  10-03 (A. Vidard) F90 translation and NEMOTAM adaptation
+   !-----------------------------------------------------------------------!
+   USE par_kind, ONLY : wp
+   PRIVATE
+   INTEGER, PARAMETER :: jpn = 624           ! period parameters
+   INTEGER, PARAMETER :: jpm = 397
+
+   INTEGER*8, PARAMETER :: jpa   = Z'9908b0df' ! constant vector A
+   INTEGER*8, PARAMETER :: jpmsb = Z'80000000' ! most significant w-r bit mask
+   INTEGER*8, PARAMETER :: jplsb = Z'7fffffff' ! least significant r bit mask
+!
+   INTEGER*8, PARAMETER :: jpall = Z'ffffffff' ! all bits mask
+
+   INTEGER*8, PARAMETER :: jptmp1= Z'9d2c5680' ! Tampering paramters
+   INTEGER*8, PARAMETER :: jptmp2= Z'efc60000'
+
+   INTEGER :: mti
+   INTEGER*8, DIMENSION(0:jpn-1) :: mt
+   LOGICAL :: l_mtinit = .FALSE.
+
+   PUBLIC &
+      & l_mtinit,   &
+      & mtrand_int31, &
+      & mtrand_int32, &
+      & mtrand_real1, &
+      & mtrand_real2, &
+      & mtrand_real3, &
+      & mtrand_real53,&
+      & init_by_array,&
+      & init_mtrand
+CONTAINS
+   SUBROUTINE init_mtrand(ks)
+!-----------------------------------------------------------------------
+!!    initialize mt(0:N-1) with a seed
+!-----------------------------------------------------------------------
+      INTEGER :: ks
+      !
+      mt(0) = IAND(INT(ks,kind=8),jpall)
+      DO mti = 1, jpn-1
+         mt(mti) = 1812433253 * IEOR(mt(mti-1),ISHFT(mt(mti-1),-30)) + mti
+         ! See Knuth TAOCP Vol2. 3rd Ed. P.106 for multiplier. 
+         ! In the previous versions, MSBs of the seed affect   
+         ! only MSBs of the array mt[].                        
+         ! modified by Makoto Matsumoto 
+         mt(mti) = IAND(mt(mti),jpall)
+         ! for >32 bit machines
+      END DO
+      l_mtinit = .TRUE.
+!
+   END SUBROUTINE init_mtrand
+   SUBROUTINE init_by_array(kinit_key,key_length)
+!-----------------------------------------------------------------------
+!     initialize by an array with array-length
+!     init_key is the array for initializing keys
+!     key_length is its length
+!-----------------------------------------------------------------------
+      INTEGER :: kinit_key(0:*)
+      INTEGER :: key_length
+      INTEGER :: ji,jj,jk
+!
+      CALL init_mtrand(19650218)
+      ji = 1
+      jj = 0
+      DO jk = MAX(jpn,key_length),1,-1
+         mt(ji) = IEOR(mt(ji),IEOR(mt(ji-1),ISHFT(mt(ji-1),-30)) * 1664525) &
+            &   + kinit_key(jj) + jj
+         mt(ji) = IAND(mt(ji),jpall)
+         ji = ji + 1
+         jj = jj + 1
+         IF (ji .GE. jpn) THEN
+            mt(0) = mt(jpn-1)
+            ji = 1
+         ENDIF
+         IF (jj .GE. key_length) THEN
+            jj = 0
+         ENDIF
+      END DO
+      DO  jk = jpn-1,1,-1
+         mt(ji) = IEOR(mt(ji),IEOR(mt(ji-1),ISHFT(mt(ji-1),-30)) * 1566083941) - ji ! non linear
+         mt(ji) = IAND(mt(ji),jpall) ! for WORDSIZE > 32 machines
+         ji = ji + 1
+         IF (ji .GE. jpn) THEN
+            mt(0) = mt(jpn-1)
+            ji = 1
+         ENDIF
+      END DO
+      mt(0) = jpmsb ! MSB is 1; assuring non-zero initial array
+!
+   END SUBROUTINE init_by_array
+   FUNCTION mtrand_int32()
+!-----------------------------------------------------------------------
+!     generates a random number on [0,0xffffffff]-interval
+!-----------------------------------------------------------------------
+      INTEGER :: mtrand_int32
+      INTEGER :: jk
+      INTEGER*8 :: iy
+      INTEGER*8, DIMENSION(0:1) :: mag01
+!
+      mag01(0)    = 0
+      mag01(1)    = jpa          ! mag01[x] = x * vector A  for x=0,1
+!
+      IF(.NOT. l_mtinit)THEN     ! if init_mtrand() has not been called
+         CALL init_mtrand(5489)  ! a default initial seed is used
+      ENDIF
+!
+      IF (mti .GE. jpn) THEN
+         DO jk = 0,jpn-jpm-1
+            iy     = IOR(IAND(mt(jk),jpmsb),IAND(mt(jk+1),jplsb))
+            mt(jk) = IEOR(IEOR(mt(jk+jpm),ISHFT(iy,-1)),mag01(IAND(iy,1)))
+         END DO
+         DO jk = jpn-jpm,jpn-1-1
+            iy     = IOR(IAND(mt(jk),jpmsb),IAND(mt(jk+1),jplsb))
+            mt(jk) = IEOR(IEOR(mt(jk+(jpm-jpn)),ISHFT(iy,-1)),mag01(IAND(iy,1)))
+         END DO
+         iy     = IOR(IAND(mt(jpn-1),jpmsb),IAND(mt(0),jplsb))
+         mt(jk) = IEOR(IEOR(mt(jpm-1),ISHFT(iy,-1)),mag01(IAND(iy,1)))
+         mti    = 0
+      ENDIF
+!
+      iy  = mt(mti)
+      mti = mti + 1
+!
+      iy = IEOR(iy,ISHFT(iy,-11))
+      iy = IEOR(iy,IAND(ISHFT(iy,7),jptmp1))
+      iy = IEOR(iy,IAND(ISHFT(iy,15),jptmp2))
+      iy = IEOR(iy,ISHFT(iy,-18))
+      !
+      mtrand_int32 = iy
+   END FUNCTION mtrand_int32
+   FUNCTION mtrand_int31()
+!-----------------------------------------------------------------------
+!     generates a random number on [0,0x7fffffff]-interval
+!-----------------------------------------------------------------------
+      INTEGER :: mtrand_int31
+      mtrand_int31 = INT(ISHFT(mtrand_int32(),-1))
+   END FUNCTION mtrand_int31
+   FUNCTION mtrand_real1()
+!-----------------------------------------------------------------------
+!     generates a random number on [0,1]-real-interval
+!-----------------------------------------------------------------------
+      REAL(wp) :: mtrand_real1, zr
+      zr = REAL(mtrand_int32(),wp)
+      IF (zr.LT.0._wp) zr = zr + 2._wp**32
+      mtrand_real1 = zr / 4294967295._wp
+   END FUNCTION mtrand_real1
+   FUNCTION mtrand_real2()
+!-----------------------------------------------------------------------
+!     generates a random number on [0,1)-real-interval
+!-----------------------------------------------------------------------
+      REAL(wp) :: mtrand_real2,zr
+      zr = REAL(mtrand_int32(),wp)
+      IF (zr.LT.0._wp) zr = zr + 2._wp**32
+      mtrand_real2=zr / 4294967296._wp
+   END FUNCTION mtrand_real2
+   FUNCTION mtrand_real3()
+!-----------------------------------------------------------------------
+!     generates a random number on (0,1)-real-interval
+!-----------------------------------------------------------------------
+      REAL(wp) :: mtrand_real3, zr
+      zr = REAL(mtrand_int32(),wp)
+      IF (zr.LT.0._wp) zr = zr + 2._wp**32
+      mtrand_real3 = ( zr + 0.5_wp ) / 4294967296._wp
+   END FUNCTION mtrand_real3
+   FUNCTION mtrand_res53()
+!-----------------------------------------------------------------------
+!     generates a random number on [0,1) with 53-bit resolution
+!-----------------------------------------------------------------------
+      REAL(wp) :: mtrand_res53
+      REAL(wp) :: za,zb
+      za = ISHFT(mtrand_int32(),-5)
+      zb = ISHFT(mtrand_int32(),-6)
+      IF (za.LT.0._wp) za = za + 2._wp**32
+      IF (zb.LT.0._wp) zb = zb + 2._wp**32
+      mtrand_res53 = ( za * 67108864._wp + zb ) / 9007199254740992._wp
+   END FUNCTION mtrand_res53
+END MODULE mt19937ar
